﻿using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;

namespace IgDoughnutTester
{
    public class MainViewModel : NotificationObject
    {
        private ObservableCollection<Parent> _chartData;
        private Item _selectedItem;

        public ObservableCollection<Parent> ChartData
        {
            get { return _chartData; }
            set
            {
                if (_chartData != value)
                {
                    _chartData = value;
                    base.OnPropertyChanged("ChartData");
                }
            }
        }

        public List<Item> Items { get; private set; }

        public Item SelectedItem
        {
            get { return _selectedItem; }
            set
            {
                if (_selectedItem != value)
                {
                    _selectedItem = value;
                    base.OnPropertyChanged("SelectedItem");
                    HandleSelectedItemChange();
                }
            }
        }

        public MainViewModel()
        {
            Items = new List<Item>
            {
                new Item { Id = 1 }, new Item { Id = 2 }, new Item{ Id = 3 }
            };

            SelectedItem = Items.First();
        }

        private void HandleSelectedItemChange()
        {
           var temp = new ObservableCollection<Parent>();

            if (SelectedItem.Id == 1)
            {
                temp.Add(new Parent
                {
                    Name = "Tester1", Value = 30, Children = new ObservableCollection<Child>
                    {
                        new Child
                        {
                            Name = "Child 1", Value = 10
                        },
                        new Child
                        {
                            Name = "Child 2", Value = 20
                        },
                    }
                });

                temp.Add(new Parent
                {
                    Name = "Tester2",
                    Value = 80,
                    Children = new ObservableCollection<Child>
                    {
                        new Child
                        {
                            Name = "Child 1", Value = 40
                        },
                        new Child
                        {
                            Name = "Child 2", Value = 20
                        },
                        new Child
                        {
                            Name = "Child 3", Value = 20
                        },
                    }
                });
            }
            else if (SelectedItem.Id == 2)
            {
                temp.Add(new Parent
                {
                    Name = "Tester1",
                    Value = 100,
                    Children = new ObservableCollection<Child>
                    {
                        new Child
                        {
                            Name = "Child 1", Value = 10
                        },
                        new Child
                        {
                            Name = "Child 2", Value = 20
                        },
                        new Child
                        {
                            Name = "Child 3", Value = 50
                        },
                        new Child
                        {
                            Name = "Child 4", Value = 20
                        },
                    }
                });
            }
            else if (SelectedItem.Id == 3)
            {
                temp.Add(new Parent
                {
                    Name = "Tester1",
                    Value = 30,
                    Children = new ObservableCollection<Child>
                    {
                        new Child
                        {
                            Name = "Child 1", Value = 10
                        },
                        new Child
                        {
                            Name = "Child 2", Value = 20
                        },
                    }
                });

                temp.Add(new Parent
                {
                    Name = "Tester2",
                    Value = 80,
                    Children = new ObservableCollection<Child>
                    {
                        new Child
                        {
                            Name = "Child 1", Value = 40
                        },
                        new Child
                        {
                            Name = "Child 2", Value = 20
                        },
                        new Child
                        {
                            Name = "Child 3", Value = 20
                        },
                    }
                });
            }

            ChartData = temp;
        }
    }
}
