﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace IgDoughnutTester
{
    public class Parent : INotifyPropertyChanged
    {
        private string _name;
        private decimal _value;
        public string Name {
            get
            {
                return _name;
            }
            set
            {
                _name = value;
                PropChanged("Name");
            }
        }
        public decimal Value {
            get
            {
                return _value;
            }
            set
            {
                _value = value;
                PropChanged("Value");
            }
        }
        private ObservableCollection<Child> _children;

        public ObservableCollection<Child> Children 
        {
            get
            {
                return _children;
            }
            set
            {
                _children = value;
                PropChanged("Children");
            }

        }

        public Parent()
        {
            Children = new ObservableCollection<Child>();
        }

        public event PropertyChangedEventHandler PropertyChanged;

        public void PropChanged(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }
    }
    
    
				
}



				
